
/*  A Bison parser, made from rp2gen_parser.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	IDENTIFIER	257
#define	NUMBER	258
#define	STRING	259
#define	SUBSYSTEM	260
#define	TIMEOUT	261
#define	DEFINE	262
#define	NEW_CONNECTION	263
#define	TYPEDEF	264
#define	RPC2_STRUCT	265
#define	RPC2_ENUM	266
#define	CLIENT	267
#define	SERVER	268
#define	PREFIX	269
#define	IN	270
#define	OUT	271

#line 1 "rp2gen_parser.y"
 /* BLURB gpl

                           Coda File System
                              Release 5

          Copyright (c) 1987-1999 Carnegie Mellon University
                  Additional copyrights listed below

This  code  is  distributed "AS IS" without warranty of any kind under
the terms of the GNU General Public Licence Version 2, as shown in the
file  LICENSE.  The  technical and financial  contributors to Coda are
listed in the file CREDITS.

                        Additional copyrights

#*/

/*
                         IBM COPYRIGHT NOTICE

                          Copyright (C) 1986
             International Business Machines Corporation
                         All Rights Reserved

This  file  contains  some  code identical to or derived from the 1986
version of the Andrew File System ("AFS"), which is owned by  the  IBM
Corporation.   This  code is provided "AS IS" and IBM does not warrant
that it is free of infringement of  any  intellectual  rights  of  any
third  party.    IBM  disclaims  liability of any kind for any damages
whatsoever resulting directly or indirectly from use of this  software
or  of  any  derivative work.  Carnegie Mellon University has obtained
permission to  modify,  distribute and sublicense this code,  which is
based on Version 2  of  AFS  and  does  not  contain  the features and
enhancements that are part of  Version 3 of  AFS.  Version 3 of AFS is
commercially   available   and  supported  by   Transarc  Corporation,
Pittsburgh, PA.

*/

#include <stdio.h>
#include <stdlib.h>
#include "rp2.h"

extern int yydebug;
extern int HeaderOnlyFlag;

extern char *copy();
extern RPC2_TYPE *rpc2_enum_type(), *rpc2_struct_type();
extern ENTRY *make_entry(), *find();
extern ENUM *make_enum();
extern VAR *make_var();
extern PROC *make_proc(), *check_proc();
extern enter();
extern char *concat();
extern struct subsystem subsystem;
extern void no_storage(char *);
extern void spit_define(char *, char *);
extern void insert(PROC *proc);

/* Structure for handling IDENTIFIER lists */

#define MAX_IDS	100

struct {
    char	*ids[MAX_IDS];
    int		counter;
} id_list;

static char **make_id_array()
{
    register char **array;
    register int i;

    array = (char **) calloc(id_list.counter+1, sizeof(char *));
    if (array == NIL) no_storage("make_id_array");
    array[id_list.counter] = NIL;
    for (i=0, id_list.counter--; id_list.counter>=0; i++, id_list.counter--)
	array[i] = id_list.ids[id_list.counter];
    return array;
}

#define MAX_ENUMS	100

struct {
    ENUM	*enums[MAX_ENUMS];
    int		counter;
} enum_list;

static ENUM **make_enum_array()
{
    register ENUM **array;
    register int i;

    array = (ENUM **) calloc(enum_list.counter+1, sizeof(ENUM *));
    if (array == NIL) no_storage("make_enum_array");
    array[enum_list.counter] = NIL;
    for (i=0, enum_list.counter--; enum_list.counter>=0; i++, enum_list.counter--)
	array[i] = enum_list.enums[enum_list.counter];
    return array;
}

#define MAX_FORMALS	100

struct {
    VAR		*formals[MAX_FORMALS];
    int		counter;
} formal_list;

static VAR **make_formal_array()
{
    register VAR **array;
    register int i;

    array = (VAR **) calloc(formal_list.counter+1, sizeof(VAR *));
    if (array == NIL) no_storage("make_formal_array");
    array[formal_list.counter] = NIL;
    for (i=0, formal_list.counter--; formal_list.counter>=0; i++, formal_list.counter--)
	array[i] = formal_list.formals[formal_list.counter];
    return array;
}

#define MAX_VARS	100

struct {
    VAR		**vars[MAX_VARS];
    int		counter;
} var_list;

static int length(p)
    char **p;
{
    register int len;

    for (len=0; *p!=NIL; p++) len++;
    return len;
}

static VAR **make_var_array()
{
    register int count, i;
    register VAR **array;

    for (i=0, count=0; i<var_list.counter; i++) count += length((char **)var_list.vars[i]);
    array = (VAR **) calloc(count+1, sizeof(VAR *));
    if (array == NIL) no_storage("make_var_array");
    array[count] = NIL;

    /* Transfer to array */
    for (i=0, var_list.counter--; var_list.counter>=0; var_list.counter--) {
	register VAR **v;
	for (v = var_list.vars[var_list.counter]; *v != NIL; v++)
	    array[i++] = *v;
    }
    return array;
}

static char *createsize(name)
    char *name;
{
    return concat(name, "_size_");
}

static char *createmaxsize(name)
    char *name;
{
    return concat(name, "_max_size_");
}

int next_opnum = 1;


#line 186 "rp2gen_parser.y"
typedef union {
    rp2_bool	u_bool;
    MODE	u_mode;
    char	*u_string;
    char	**u_string_array;
    RPC2_TYPE	*u_rpc2_type;
    ENTRY	*u_entry;
    ENUM	*u_enum;
    VAR		*u_var;
    VAR		**u_var_array;
    VAR		***u_var_array_array;
    int         u_int;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		115
#define	YYFLAG		-32768
#define	YYNTBASE	28

#define YYTRANSLATE(x) ((unsigned)(x) <= 271 ? yytranslate[x] : 63)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    19,
    20,     2,     2,    23,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    27,    18,     2,
    24,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    25,     2,    26,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    21,     2,    22,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     5,     7,     9,    12,    17,    22,    27,    29,    32,
    34,    36,    38,    40,    46,    48,    51,    53,    55,    57,
    59,    63,    67,    73,    75,    77,    79,    81,    86,    89,
    91,    95,    97,   101,   103,   108,   112,   114,   118,   122,
   124,   127,   129,   138,   141,   143,   148,   151,   153,   157,
   159,   161,   164,   169,   171,   173,   175,   177,   179,   181
};

static const short yyrhs[] = {    29,
    31,    36,    37,     0,    62,     0,    30,     0,    30,    30,
     0,    14,    15,    61,    18,     0,    13,    15,    61,    18,
     0,     6,    33,    32,    18,     0,    62,     0,    34,    35,
     0,    62,     0,    61,     0,    60,     0,    60,     0,     7,
    19,    60,    20,    18,     0,    62,     0,    37,    38,     0,
    62,     0,    40,     0,    39,     0,    53,     0,     8,     3,
     4,     0,     8,     3,    61,     0,    10,    41,     3,    51,
    18,     0,    42,     0,    43,     0,    48,     0,     3,     0,
    11,    21,    44,    22,     0,    45,    44,     0,    45,     0,
    42,    46,    18,     0,    47,     0,     3,    23,    47,     0,
     3,     0,    12,    21,    49,    22,     0,    50,    23,    49,
     0,    50,     0,     3,    24,     4,     0,    25,    60,    26,
     0,    62,     0,    25,    26,     0,    62,     0,    54,     3,
    19,    55,    20,    58,    59,    18,     0,     4,    27,     0,
    62,     0,    56,    52,    23,    55,     0,    56,    52,     0,
    62,     0,    57,    42,     3,     0,    16,     0,    17,     0,
    16,    17,     0,     7,    19,    60,    20,     0,    62,     0,
     9,     0,    62,     0,     4,     0,     3,     0,     5,     0,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   226,   229,   230,   231,   234,   240,   248,   253,   260,   262,
   265,   269,   273,   277,   279,   283,   284,   287,   288,   289,
   293,   295,   299,   314,   316,   318,   322,   332,   336,   344,
   351,   364,   367,   375,   382,   386,   394,   401,   405,   407,
   411,   415,   419,   432,   435,   440,   468,   491,   495,   501,
   503,   505,   509,   511,   514,   516,   520,   522,   526,   534
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","IDENTIFIER",
"NUMBER","STRING","SUBSYSTEM","TIMEOUT","DEFINE","NEW_CONNECTION","TYPEDEF",
"RPC2_STRUCT","RPC2_ENUM","CLIENT","SERVER","PREFIX","IN","OUT","';'","'('",
"')'","'{'","'}'","','","'='","'['","']'","':'","file","prefixes","prefix","header_line",
"compatability_stuff","subsystem_name","id_number","protocol_version","default_timeout",
"decl_or_proc_list","decl_or_proc","define","typedef","rpc2_type","type_name",
"rpc2_struct","field_list","field","identifier_list","identifier_list2","rpc2_enum",
"enum_val_list","enum_val","array_spec","array_spec_var","procedure_description",
"opcode_number","formal_list","formal","usage","timeout_override","new_connection",
"DefinedNumber","String","empty", NULL
};
#endif

static const short yyr1[] = {     0,
    28,    29,    29,    29,    30,    30,    31,    31,    32,    32,
    33,    34,    35,    36,    36,    37,    37,    38,    38,    38,
    39,    39,    40,    41,    41,    41,    42,    43,    44,    44,
    45,    46,    47,    47,    48,    49,    49,    50,    51,    51,
    52,    52,    53,    54,    54,    55,    55,    55,    56,    57,
    57,    57,    58,    58,    59,    59,    60,    60,    61,    62
};

static const short yyr2[] = {     0,
     4,     1,     1,     2,     4,     4,     4,     1,     2,     1,
     1,     1,     1,     5,     1,     2,     1,     1,     1,     1,
     3,     3,     5,     1,     1,     1,     1,     4,     2,     1,
     3,     1,     3,     1,     4,     3,     1,     3,     3,     1,
     2,     1,     8,     2,     1,     4,     2,     1,     3,     1,
     1,     2,     4,     1,     1,     1,     1,     1,     1,     0
};

static const short yydefact[] = {    60,
     0,     0,    60,     3,     2,     0,     0,     0,    60,     8,
     4,    59,     0,     0,    60,    11,     0,    60,    15,     6,
     5,    58,    57,     0,     0,    12,    10,     0,     1,    17,
     7,     9,    13,     0,     0,     0,     0,    16,    19,    18,
    20,     0,    45,     0,    44,     0,    27,     0,     0,     0,
    24,    25,    26,     0,    14,    21,    22,     0,     0,    60,
    60,     0,     0,    30,     0,     0,    37,     0,     0,    40,
    50,    51,     0,    60,     0,    48,    34,     0,    32,    28,
    29,     0,    35,     0,     0,    23,    52,    60,     0,    47,
    42,     0,     0,    31,    38,    36,    39,     0,    60,    54,
    41,    60,    49,    33,     0,    55,     0,    56,    46,     0,
    43,    53,     0,     0,     0
};

static const short yydefgoto[] = {   113,
     3,     4,     9,    24,    15,    25,    32,    18,    29,    38,
    39,    40,    50,    62,    52,    63,    64,    78,    79,    53,
    66,    67,    69,    90,    41,    42,    73,    74,    75,    99,
   107,    26,    13,    76
};

static const short yypact[] = {    -3,
    -7,     7,     6,    -3,-32768,    23,    23,    23,    24,-32768,
-32768,-32768,    12,    14,    16,-32768,    15,-32768,-32768,-32768,
-32768,-32768,-32768,    17,    16,-32768,-32768,    16,    13,-32768,
-32768,-32768,-32768,    18,     9,    30,     2,-32768,-32768,-32768,
-32768,    34,-32768,    21,-32768,    20,-32768,    22,    25,    38,
-32768,-32768,-32768,    28,-32768,-32768,-32768,    39,    45,    26,
    10,    46,    31,    39,    32,    33,    27,    16,    36,-32768,
    35,-32768,    37,    40,    39,-32768,    41,    43,-32768,-32768,
-32768,    54,-32768,    45,    42,-32768,-32768,    52,    44,    48,
-32768,    59,    46,-32768,-32768,-32768,-32768,    47,    58,-32768,
-32768,    10,-32768,-32768,    16,-32768,    51,-32768,-32768,    53,
-32768,-32768,    63,    72,-32768
};

static const short yypgoto[] = {-32768,
-32768,    71,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   -35,-32768,    19,-32768,-32768,   -17,-32768,
    -6,-32768,-32768,-32768,-32768,-32768,   -25,-32768,-32768,-32768,
-32768,   -24,    -1,     0
};


#define	YYLAST		99


static const short yytable[] = {     5,
    33,    51,    10,    34,    47,    14,    16,     6,    19,     1,
     2,     8,    48,    49,    27,   -60,    35,    30,    22,    23,
    36,     7,    37,    56,    12,    71,    72,    12,    43,    20,
    17,    21,    46,    28,    31,    45,    54,    44,    55,    92,
    60,    47,    58,    85,    57,    59,    61,    65,    77,    84,
    68,    87,    80,    86,    83,    82,    88,    95,    98,    70,
    94,   103,   114,    93,    89,   105,   106,    97,   111,   101,
   102,   115,   112,    91,    11,   104,   109,    96,     0,     0,
   110,     0,    81,     0,     0,     0,     0,   100,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   108
};

static const short yycheck[] = {     0,
    25,    37,     3,    28,     3,     7,     8,    15,     9,    13,
    14,     6,    11,    12,    15,     3,     4,    18,     3,     4,
     8,    15,    10,     4,     5,    16,    17,     5,    29,    18,
     7,    18,     3,    19,    18,    27,     3,    20,    18,    75,
     3,     3,    21,    68,    46,    21,    19,     3,     3,    23,
    25,    17,    22,    18,    22,    24,    20,     4,     7,    60,
    18,     3,     0,    23,    25,    19,     9,    26,    18,    26,
    23,     0,    20,    74,     4,    93,   102,    84,    -1,    -1,
   105,    -1,    64,    -1,    -1,    -1,    -1,    88,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    99
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 5:
#line 235 "rp2gen_parser.y"
{
					    extern char *server_prefix;
					    server_prefix = copy(yyvsp[-1].u_string+1);
					    server_prefix[strlen(server_prefix)-1] = '\0';
					;
    break;}
case 6:
#line 241 "rp2gen_parser.y"
{
					    extern char *client_prefix;
					    client_prefix = copy(yyvsp[-1].u_string+1);
					    client_prefix[strlen(client_prefix)-1] = '\0';
					;
    break;}
case 7:
#line 249 "rp2gen_parser.y"
{
					    subsystem.subsystem_name = copy(yyvsp[-2].u_string+1);
					    subsystem.subsystem_name[strlen(subsystem.subsystem_name)-1] = '\0';
					;
    break;}
case 8:
#line 254 "rp2gen_parser.y"
{
			    printf("NO SUBSYSTEM SPECIFIED: only generating header file\n");
			    HeaderOnlyFlag = 1;
			    ;
    break;}
case 9:
#line 261 "rp2gen_parser.y"
{;
    break;}
case 11:
#line 266 "rp2gen_parser.y"
{ yyval.u_string = yyvsp[0].u_string; ;
    break;}
case 12:
#line 270 "rp2gen_parser.y"
{ yyval.u_string = yyvsp[0].u_string; ;
    break;}
case 13:
#line 274 "rp2gen_parser.y"
{ yyval.u_string = yyvsp[0].u_string; ;
    break;}
case 14:
#line 278 "rp2gen_parser.y"
{ subsystem.timeout = yyvsp[-2].u_string; ;
    break;}
case 15:
#line 280 "rp2gen_parser.y"
{ subsystem.timeout = NIL; ;
    break;}
case 20:
#line 290 "rp2gen_parser.y"
{;
    break;}
case 21:
#line 294 "rp2gen_parser.y"
{ if (yyvsp[-2].u_bool) spit_define(yyvsp[-1].u_string, yyvsp[0].u_string); ;
    break;}
case 22:
#line 296 "rp2gen_parser.y"
{ if (yyvsp[-2].u_bool) spit_define(yyvsp[-1].u_string, yyvsp[0].u_string); ;
    break;}
case 23:
#line 300 "rp2gen_parser.y"
{
					    extern spit_type();
					    yyvsp[-3].u_entry -> name = yyvsp[-2].u_string;
					    yyvsp[-3].u_entry -> bound = yyvsp[-1].u_string;
					    if (yyvsp[-3].u_entry->bound != NIL && yyvsp[-3].u_entry->type->tag != RPC2_BYTE_TAG) {
						printf("RP2GEN: array type unimplemented: %s\n",
						       yyvsp[-2].u_string);
						exit(1);
					    }
					    enter(yyvsp[-3].u_entry);
					    if (yyvsp[-4].u_bool) spit_type(yyvsp[-3].u_entry);
					;
    break;}
case 24:
#line 315 "rp2gen_parser.y"
{ yyval.u_entry = make_entry(yyvsp[0].u_entry->type, yyvsp[0].u_entry); ;
    break;}
case 25:
#line 317 "rp2gen_parser.y"
{ yyval.u_entry = make_entry(yyvsp[0].u_rpc2_type, NIL); ;
    break;}
case 26:
#line 319 "rp2gen_parser.y"
{ yyval.u_entry = make_entry(yyvsp[0].u_rpc2_type, NIL); ;
    break;}
case 27:
#line 323 "rp2gen_parser.y"
{
					    yyval.u_entry = find(yyvsp[0].u_string);
					    if (yyval.u_entry == NIL) {
						printf("RP2GEN: can't find type: %s\n", yyvsp[0].u_string);
						exit(1);
					    }
					;
    break;}
case 28:
#line 333 "rp2gen_parser.y"
{ yyval.u_rpc2_type = rpc2_struct_type(make_var_array()); ;
    break;}
case 29:
#line 337 "rp2gen_parser.y"
{
					    if (var_list.counter >= MAX_VARS) {
						printf("RP2GEN: too many fields: %d\n", MAX_VARS);
						exit(1);
					    }
					    var_list.vars[var_list.counter++] = yyvsp[-1].u_var_array;
					;
    break;}
case 30:
#line 345 "rp2gen_parser.y"
{
					    var_list.vars[0] = yyvsp[0].u_var_array;
					    var_list.counter = 1;
					;
    break;}
case 31:
#line 352 "rp2gen_parser.y"
{
					    register char **id;
					    register VAR **p;
					    yyval.u_var_array = (VAR **) calloc(length(yyvsp[-1].u_string_array)+1, sizeof(VAR *));
					    if (yyval.u_var_array == NIL) no_storage("field");
					    for (id=yyvsp[-1].u_string_array, p=yyval.u_var_array; *id!=NIL; id++, p++)
						*p = make_var(*id, NO_MODE, yyvsp[-2].u_entry);
					    *p = NIL;
					    free(yyvsp[-1].u_string_array);
					;
    break;}
case 32:
#line 365 "rp2gen_parser.y"
{ yyval.u_string_array = make_id_array(); ;
    break;}
case 33:
#line 368 "rp2gen_parser.y"
{
					    if (id_list.counter >= MAX_IDS) {
						printf("RP2GEN: too many identifiers in list: %d\n", MAX_IDS);
						exit(1);
					    }
					    id_list.ids[id_list.counter++] = yyvsp[-2].u_string;
					;
    break;}
case 34:
#line 376 "rp2gen_parser.y"
{
					    id_list.ids[0] = yyvsp[0].u_string;
					    id_list.counter = 1;
					;
    break;}
case 35:
#line 383 "rp2gen_parser.y"
{ yyval.u_rpc2_type = rpc2_enum_type(make_enum_array()); ;
    break;}
case 36:
#line 387 "rp2gen_parser.y"
{
					    if (enum_list.counter >= MAX_ENUMS) {
						printf("RP2GEN: too many enum values: %d\n", MAX_ENUMS);
						exit(1);
					    }
					    enum_list.enums[enum_list.counter++] = yyvsp[-2].u_enum;
					;
    break;}
case 37:
#line 395 "rp2gen_parser.y"
{
					    enum_list.enums[0] = yyvsp[0].u_enum;
					    enum_list.counter = 1;
					;
    break;}
case 38:
#line 402 "rp2gen_parser.y"
{ yyval.u_enum = make_enum(yyvsp[-2].u_string, yyvsp[0].u_string); ;
    break;}
case 39:
#line 406 "rp2gen_parser.y"
{ yyval.u_string = yyvsp[-1].u_string; ;
    break;}
case 40:
#line 408 "rp2gen_parser.y"
{ yyval.u_string = NIL; ;
    break;}
case 41:
#line 412 "rp2gen_parser.y"
{
					    yyval.u_var = make_var(NIL, NO_MODE, find("RPC2_Integer"));
					;
    break;}
case 42:
#line 416 "rp2gen_parser.y"
{ yyval.u_var = NIL; ;
    break;}
case 43:
#line 420 "rp2gen_parser.y"
{ if (yyvsp[-1].u_bool == RP2_FALSE) {
                                            if (yyvsp[-7].u_int == -1)
                                                yyvsp[-7].u_int = next_opnum;
                                            if (yyvsp[-7].u_int < next_opnum) {
                                              printf("RP2GEN: Opcode numbers must be always increasing\n");
                                              exit(1);
                                            }
                                            next_opnum = yyvsp[-7].u_int + 1;
                                          }
					  insert(check_proc(make_proc(yyvsp[-7].u_int, yyvsp[-6].u_string, make_formal_array(), yyvsp[-2].u_string, yyvsp[-1].u_bool))); ;
    break;}
case 44:
#line 433 "rp2gen_parser.y"
{ yyval.u_int = atoi(yyvsp[-1].u_string); ;
    break;}
case 45:
#line 436 "rp2gen_parser.y"
{ yyval.u_int = -1; ;
    break;}
case 46:
#line 441 "rp2gen_parser.y"
{
					    register VAR *maxvarp;
					    if (formal_list.counter >= MAX_FORMALS) {
						printf("RP2GEN: too many formals: %d\n", MAX_FORMALS);
						exit(1);
					    }
					    formal_list.formals[formal_list.counter++] = yyvsp[-3].u_var;
					    if (yyvsp[-2].u_var != NIL) {
						if (formal_list.counter >= MAX_FORMALS) {
						    printf("RP2GEN: too many formals: %d\n", MAX_FORMALS);
						    exit(1);
						}
					        if (yyvsp[-3].u_var->type->type->tag != RPC2_STRUCT_TAG) {
						    printf("RP2GEN: array type unimplemented: %s\n", yyvsp[-3].u_var->name);
						    exit(1);
					        } 
					        formal_list.formals[formal_list.counter++] = yyvsp[-2].u_var;
						yyvsp[-3].u_var->array = yyvsp[-2].u_var->name = createsize(yyvsp[-3].u_var->name);
						yyvsp[-2].u_var->mode = yyvsp[-3].u_var->mode;
						if (yyvsp[-3].u_var->mode != IN_MODE) { 
						    maxvarp = make_var(NIL, NO_MODE, find("RPC2_Integer"));
						    yyvsp[-3].u_var->arraymax = maxvarp->name = createmaxsize(yyvsp[-3].u_var->name);
						    maxvarp->mode = IN_MODE;
						    formal_list.formals[formal_list.counter++] = maxvarp;
						}
					    }
					;
    break;}
case 47:
#line 469 "rp2gen_parser.y"
{
					    register VAR *maxvarp;
					    formal_list.formals[0] = yyvsp[-1].u_var;
					    formal_list.counter = 1;
					    if (yyvsp[0].u_var != NIL) {
					        if (yyvsp[-1].u_var->type->type->tag != RPC2_STRUCT_TAG) {
						    printf("RP2GEN: array type unimplemented: %s\n",
						           yyvsp[-1].u_var /* Is this a char *?*/);
						    exit(1);
					        } 
					        formal_list.formals[formal_list.counter++] = yyvsp[0].u_var;
						yyvsp[-1].u_var->array = yyvsp[0].u_var->name = createsize(yyvsp[-1].u_var->name);
						yyvsp[0].u_var->mode = yyvsp[-1].u_var->mode;
						if (yyvsp[-1].u_var->mode != IN_MODE) { 
						    maxvarp = make_var(NIL, NO_MODE, find("RPC2_Integer"));
						    yyvsp[-1].u_var->arraymax = maxvarp->name = createmaxsize(yyvsp[-1].u_var->name);
						    maxvarp->mode = IN_MODE;
						    formal_list.formals[formal_list.counter++] = maxvarp;
						}
					    }

					;
    break;}
case 48:
#line 492 "rp2gen_parser.y"
{ formal_list.counter = 0; ;
    break;}
case 49:
#line 496 "rp2gen_parser.y"
{
					  yyval.u_var = make_var(yyvsp[0].u_string, yyvsp[-2].u_mode, yyvsp[-1].u_entry);
					;
    break;}
case 50:
#line 502 "rp2gen_parser.y"
{ yyval.u_mode = IN_MODE; ;
    break;}
case 51:
#line 504 "rp2gen_parser.y"
{ yyval.u_mode = OUT_MODE; ;
    break;}
case 52:
#line 506 "rp2gen_parser.y"
{ yyval.u_mode = IN_OUT_MODE; ;
    break;}
case 53:
#line 510 "rp2gen_parser.y"
{ yyval.u_string = yyvsp[-1].u_string; ;
    break;}
case 54:
#line 512 "rp2gen_parser.y"
{ yyval.u_string = NIL; ;
    break;}
case 55:
#line 515 "rp2gen_parser.y"
{ yyval.u_bool = RP2_TRUE; ;
    break;}
case 56:
#line 517 "rp2gen_parser.y"
{ yyval.u_bool = RP2_FALSE; ;
    break;}
case 57:
#line 521 "rp2gen_parser.y"
{ yyval.u_string = yyvsp[0].u_string; ;
    break;}
case 58:
#line 523 "rp2gen_parser.y"
{ yyval.u_string = yyvsp[0].u_string; ;
    break;}
case 59:
#line 527 "rp2gen_parser.y"
{ yyval.u_string = yyvsp[0].u_string; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 536 "rp2gen_parser.y"

